diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index d8b15d3b8..a16cb0c84 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -110,13 +110,13 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         float pixel = 0.125F;
         List<T> list;
         switch (sideFromMeta(meta)) {
-            case BOTTOM: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel).move(x, y, z)); break;
-            case TOP: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).move(x, y, z)); break;
-            case NORTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel)).move(x, y, z)); break;
-            case SOUTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1).move(x, y, z)); break;
-            case WEST: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel).move(x, y, z)); break;
+            case BOTTOM: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel).move(x, y, z)); break;
+            case TOP: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).move(x, y, z)); break;
+            case NORTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel)).move(x, y, z)); break;
+            case SOUTH: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1).move(x, y, z)); break;
+            case WEST: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel).move(x, y, z)); break;
             case EAST:
-            default: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).move(x, y, z)); break;
+            default: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).move(x, y, z)); break;
         }
 
         if(list != null)
@@ -169,13 +169,13 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         boolean isPressed = isPressed(meta);
         float pixel = 0.0625F;
         switch (sideFromMeta(meta)) {
-            case BOTTOM: return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel);
-            case TOP: return AABB.getTemporaryBB(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel);
-            case NORTH: return AABB.getTemporaryBB(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel));
-            case SOUTH: return AABB.getTemporaryBB(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1);
-            case WEST: return AABB.getTemporaryBB(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel);
+            case BOTTOM: return AABB.fromPool(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel/2f : pixel), 1.0F - pixel);
+            case TOP: return AABB.fromPool(pixel, 1f - (isPressed ? pixel/2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            case NORTH: return AABB.fromPool(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel/2f : pixel));
+            case SOUTH: return AABB.fromPool(pixel, pixel, 1f - (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel, 1);
+            case WEST: return AABB.fromPool(0, pixel, pixel, (isPressed ? pixel/2f : pixel), 1 - pixel, 1 - pixel);
             case EAST:
-            default: return AABB.getTemporaryBB(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel);
+            default: return AABB.fromPool(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index 9781fe381..cb611e085 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -55,9 +55,9 @@ public class BlockLogicRail extends BlockLogic {
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
         RailDirection direction = getRailDirection(world, x, y, z);
         if(direction.isSloped()) {
-            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
+            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
         } else {
-            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index e912ac8c7..fa4ede3d8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -67,7 +67,7 @@ public class BlockLogicRailDetector extends BlockLogicRail {
         boolean isPowered = (meta & MASK_POWERED) != 0;
         boolean minecartPresent = false;
         float offset = 0.125f;
-        List<EntityMinecart> list = world.getEntitiesWithinAABB(EntityMinecart.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
+        List<EntityMinecart> list = world.getEntitiesWithinAABB(EntityMinecart.class, AABB.fromPool(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
         if(!list.isEmpty()) {
             minecartPresent = true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index 7bb4ca090..ce16bbeec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -64,7 +64,7 @@ public class BlockLogicRope
         if (hasBlockNegZ) minZ = 0;
         if (hasBlockPosZ) maxZ = 1;
 
-        return AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+        return AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 3ddecd935..00009d94f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -51,15 +51,15 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
         float thickness = 2.0f / 16f;
         switch (world.getBlockMetadata(x, y, z) & MASK_SIDE) {
             case SIDE_NORTH:
-                return AABB.getTemporaryBB(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
+                return AABB.fromPool(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
             case SIDE_SOUTH:
-                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, width, top, thickness);
+                return AABB.fromPool(0.0F, bottom, 0.0F, width, top, thickness);
             case SIDE_WEST:
-                return AABB.getTemporaryBB(1.0F - thickness, bottom, 0.0F, 1.0F, top, width);
+                return AABB.fromPool(1.0F - thickness, bottom, 0.0F, 1.0F, top, width);
             case SIDE_EAST:
-                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, thickness, top, width);
+                return AABB.fromPool(0.0F, bottom, 0.0F, thickness, top, width);
             default:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index e230cf2a4..6cc101808 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -57,12 +57,12 @@ public class BlockLogicSlab extends BlockLogic
         int l = world.getBlockMetadata(x, y, z) & 0x3;
         switch (l) {
             case 0:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
             case 1:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             case 2:
             default:
-                return AABB.getTemporaryBB(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
index b326e2e02..f3ec76a3a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
@@ -18,7 +18,7 @@ public class BlockLogicSoulSand extends BlockLogic
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.125F;
-        return AABB.getTemporaryBB(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
+        return AABB.fromPool(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 3fc0a62a9..1c815a00b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -71,7 +71,7 @@ public class BlockLogicSpikes extends BlockLogic
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float thickness = 3/16f;
-        return AABB.getTemporaryBB(x, y, z, x + 1,y + thickness, z + 1);
+        return AABB.fromPool(x, y, z, x + 1,y + thickness, z + 1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index df021c4f0..76b42e69b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -131,20 +131,20 @@ public class BlockLogicStairs extends BlockLogic
 
         switch (hRotation) {
             case 0:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
                 break;
             case 1:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
                 break;
             case 2:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
                 break;
             default:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
                 break;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 2ff1784a7..277320a62 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -40,17 +40,17 @@ public class BlockLogicTorch extends BlockLogic
         int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
         switch (side) {
             case SIDE_WEST:
-                return AABB.getTemporaryBB(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+                return AABB.fromPool(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
             case SIDE_EAST:
-                return AABB.getTemporaryBB(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+                return AABB.fromPool(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
             case SIDE_NORTH:
-                return AABB.getTemporaryBB(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+                return AABB.fromPool(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
             case SIDE_SOUTH:
-                return AABB.getTemporaryBB(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+                return AABB.fromPool(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
             case SIDE_BOTTOM:
             default:
                 final float f1 = 0.1F;
-                return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+                return AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index a92405fd2..834428ec4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -63,20 +63,20 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
         if (isTrapdoorOpen(meta)) {
             switch (meta & MASK_DIRECTION) {
                 case DIRECTION_SOUTH:  // South
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 1.0F - thickness, 1.0F, 1.0F, 1.0F);
                 case DIRECTION_NORTH:  // North
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, thickness);
                 case DIRECTION_EAST:  // East
-                    return AABB.getTemporaryBB(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(1.0F - thickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case DIRECTION_WEST:  // West
                 default:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, thickness, 1.0F, 1.0F);
             }
         } else {
             if (isUpperHalf(meta)) {
-                return AABB.getTemporaryBB(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
+                return AABB.fromPool(0.0F, 1.0f - thickness, 0.0F, 1.0F, 1.0f, 1.0F);
             } else {
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index ac116064d..cd3486e9c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -153,7 +153,7 @@ public class TileEntityBasket extends TileEntity
             return;
         }
 
-        final AABB aabb = AABB.getTemporaryBB(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
+        final AABB aabb = AABB.fromPool(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
 
         final List<EntityItem> entities = workingWorld.getEntitiesWithinAABB(EntityItem.class, aabb);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index 94c334efb..3d141b458 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.util.HashMap;
@@ -20,11 +21,12 @@ public class TileEntityDispatcher {
         if(idToClassMap.containsKey(id)) {
             throw new IllegalArgumentException("Duplicate id: " + id);
         }
-        id.makePermanent();
 
-        idToClassMap.put(id, entityClass);
-        stringToClassMap.put(id.toString(), entityClass);
-        classToIdMap.put(entityClass, id);
+        final @NotNull NamespaceID unpooledId = id.copyUnpooled();
+
+        idToClassMap.put(unpooledId, entityClass);
+        stringToClassMap.put(unpooledId.toString(), entityClass);
+        classToIdMap.put(entityClass, unpooledId);
     }
 
     public static TileEntity createAndLoadEntity(CompoundTag compoundTag)
@@ -69,24 +71,24 @@ public class TileEntityDispatcher {
     public static void init() {
         if (hasInit) return;
         hasInit = true;
-        addMapping(TileEntityFurnace.class, NamespaceID.getPermanent("minecraft", "furnace"));
-        addMapping(TileEntityChest.class, NamespaceID.getPermanent("minecraft", "chest"));
-        addMapping(TileEntityJukebox.class, NamespaceID.getPermanent("minecraft", "jukebox"));
-        addMapping(TileEntityDispenser.class, NamespaceID.getPermanent("minecraft", "dispenser"));
-        addMapping(TileEntityActivator.class, NamespaceID.getPermanent("minecraft", "activator"));
-        addMapping(TileEntitySign.class, NamespaceID.getPermanent("minecraft", "sign"));
-        addMapping(TileEntityMobSpawner.class, NamespaceID.getPermanent("minecraft", "mob_spawner"));
-        addMapping(TileEntityMovingPistonBlock.class, NamespaceID.getPermanent("minecraft", "piston_moving"));
-        addMapping(TileEntityFurnaceBlast.class, NamespaceID.getPermanent("minecraft", "furnace_blast"));
-        addMapping(TileEntitySensor.class, NamespaceID.getPermanent("minecraft", "sensor"));
-        addMapping(TileEntityTrommel.class, NamespaceID.getPermanent("minecraft", "trommel"));
-        addMapping(TileEntityBasket.class, NamespaceID.getPermanent("minecraft", "basket"));
-        addMapping(TileEntityFlag.class, NamespaceID.getPermanent("minecraft", "flag"));
-        addMapping(TileEntitySeat.class, NamespaceID.getPermanent("minecraft", "seat"));
-        addMapping(TileEntityFlowerJar.class, NamespaceID.getPermanent("minecraft", "jar_flower"));
-        addMapping(TileEntityJarButterfly.class, NamespaceID.getPermanent("minecraft", "jar_butterfly"));
-        addMapping(TileEntityMeshGold.class, NamespaceID.getPermanent("minecraft", "mesh_gold"));
-        addMapping(TileEntityStatue.class, NamespaceID.getPermanent("minecraft", "statue_stone"));
+        addMapping(TileEntityFurnace.class, NamespaceID.fromPool("minecraft", "furnace"));
+        addMapping(TileEntityChest.class, NamespaceID.fromPool("minecraft", "chest"));
+        addMapping(TileEntityJukebox.class, NamespaceID.fromPool("minecraft", "jukebox"));
+        addMapping(TileEntityDispenser.class, NamespaceID.fromPool("minecraft", "dispenser"));
+        addMapping(TileEntityActivator.class, NamespaceID.fromPool("minecraft", "activator"));
+        addMapping(TileEntitySign.class, NamespaceID.fromPool("minecraft", "sign"));
+        addMapping(TileEntityMobSpawner.class, NamespaceID.fromPool("minecraft", "mob_spawner"));
+        addMapping(TileEntityMovingPistonBlock.class, NamespaceID.fromPool("minecraft", "piston_moving"));
+        addMapping(TileEntityFurnaceBlast.class, NamespaceID.fromPool("minecraft", "furnace_blast"));
+        addMapping(TileEntitySensor.class, NamespaceID.fromPool("minecraft", "sensor"));
+        addMapping(TileEntityTrommel.class, NamespaceID.fromPool("minecraft", "trommel"));
+        addMapping(TileEntityBasket.class, NamespaceID.fromPool("minecraft", "basket"));
+        addMapping(TileEntityFlag.class, NamespaceID.fromPool("minecraft", "flag"));
+        addMapping(TileEntitySeat.class, NamespaceID.fromPool("minecraft", "seat"));
+        addMapping(TileEntityFlowerJar.class, NamespaceID.fromPool("minecraft", "jar_flower"));
+        addMapping(TileEntityJarButterfly.class, NamespaceID.fromPool("minecraft", "jar_butterfly"));
+        addMapping(TileEntityMeshGold.class, NamespaceID.fromPool("minecraft", "mesh_gold"));
+        addMapping(TileEntityStatue.class, NamespaceID.fromPool("minecraft", "statue_stone"));
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 79bd83c8b..8531e895a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -102,7 +102,7 @@ public class TileEntityMobSpawner extends TileEntity
                 {
                     return;
                 }
-                int j = worldObj.getEntitiesWithinAABB(mob.getClass(), AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
+                int j = worldObj.getEntitiesWithinAABB(mob.getClass(), AABB.fromPool(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
                 if(j >= 6)
                 {
                     updateDelay();
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index 895fa8e4d..3bb024159 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -60,7 +60,7 @@ public class TileEntitySensor extends TileEntity {
 		double maxY = Math.max(y1, y2) + 1;
 		double maxZ = Math.max(z1, z2) + 1;
 		
-		return AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+		return AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ);
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
index a31644738..76abee11c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
@@ -132,9 +132,12 @@ public class MaterialColor {
                 registerManualBlockColor(Blocks.TRAPDOOR_PLANKS_PAINTED, i << 4 | j, color);
                 registerManualBlockColor(Blocks.DOOR_PLANKS_PAINTED_BOTTOM, i << 4 | j, color);
                 registerManualBlockColor(Blocks.DOOR_PLANKS_PAINTED_TOP, i << 4 | j, color);
+                registerManualBlockColor(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, i << 4 | j, color);
             }
             registerManualBlockColor(Blocks.LAMP_ACTIVE, i, color);
             registerManualBlockColor(Blocks.LAMP_IDLE, i, color);
+            registerManualBlockColor(Blocks.LAMP_INVERTED_ACTIVE, i, color);
+            registerManualBlockColor(Blocks.LAMP_INVERTED_IDLE, i, color);
         }
 
         for (int i = 1; i < 256; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 47cffcc7a..d1230c773 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -189,22 +189,22 @@ public class BlockLogicPistonBase extends BlockLogic
             switch(getDirection(data))
             {
                 case DOWN:
-                    return AABB.getTemporaryBB(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case UP:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
                 case NORTH:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
                 case SOUTH:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
                 case WEST:
-                    return AABB.getTemporaryBB(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case EAST:
                 default:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
             }
         } else
         {
-            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index 496c5a056..a2d50aa90 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -38,22 +38,22 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
             switch(getDirection(data))
             {
                 case DOWN:
-                    return AABB.getTemporaryBB(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
                 case UP:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
                 case NORTH:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
                 case SOUTH:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
                 case WEST:
-                    return AABB.getTemporaryBB(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    return AABB.fromPool(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 case EAST:
                 default:
-                    return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
+                    return AABB.fromPool(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
             }
         } else
         {
-            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
@@ -196,7 +196,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
 
     @Override
     public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
-        List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
+        List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.fromPool((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
         for (Entity entity : entityList){
             if (entity == null || entity.noPhysics || entity == flungBlock /*Fix for 1 tick extensions not working properly*/
                 || (entity.world != null && entity.world.isClientSide && entity instanceof Player)) continue;
